require_dependency 'application_helper'

module RepoPygmentsApplicationHelperPatch
  def self.included(base) # :nodoc:
    base.send(:include, InstanceMethods)

    base.class_eval do
      alias_method_chain :syntax_highlight, :py_syntax_highlight
    end
  end

  module InstanceMethods
    def syntax_highlight_with_py_syntax_highlight(name, content)
      @code_css = "line-code"
      if system("python --version")
        file_name = File.basename name
        cmd_str = "python vendor/plugins/redmine_repo_pygments/lib/python_code/pyscm.py"
        scm_file_content = IO.popen(cmd_str, "w+") do |pipe|
          pipe.puts file_name.to_s
          pipe.puts content
          pipe.close_write
          pipe.read
        end
        @code_css = "highlight"
        scm_file_content
      else
        type = CodeRay::FileType[name]
        type ? CodeRay.scan(content, type).html : h(content)
      end
    end
  end
end

ApplicationHelper.send(:include, RepoPygmentsApplicationHelperPatch)